

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.22. sub_filter &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.15.23. time_classify_day" href="time_classify_day.html" />
    <link rel="prev" title="7.15.21. string_substring" href="string_substring.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/functions/sub_filter.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="time_classify_day.html" title="7.15.23. time_classify_day"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="string_substring.html" title="7.15.21. string_substring"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.22. </span><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="sub-filter">
<h1><span class="section-number">7.15.22. </span><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code><a class="headerlink" href="#sub-filter" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.22.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code> evaluates <code class="docutils literal notranslate"><span class="pre">filter_string</span></code> in <code class="docutils literal notranslate"><span class="pre">scope</span></code> context.</p>
<p><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code> can be used in only <code class="docutils literal notranslate"><span class="pre">--filter</span></code> in
<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a>.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.22.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code> requires two arguments. They are <code class="docutils literal notranslate"><span class="pre">scope</span></code> and
<code class="docutils literal notranslate"><span class="pre">filter_string</span></code>.</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>sub_filter(scope, filter_string)
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.22.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here are a schema definition and sample data to show usage.</p>
<p>Sample schema:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Comment TABLE_PAT_KEY UInt32
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Comment name COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Comment content COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Blog TABLE_PAT_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Blog title COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Blog content COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Blog comments COLUMN_VECTOR Comment
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Comment blog_comment_index COLUMN_INDEX Blog comments
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Lexicon TABLE_PAT_KEY ShortText --default_tokenizer TokenBigram
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Lexicon comment_content COLUMN_INDEX|WITH_POSITION Comment content
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Lexicon comment_name COLUMN_INDEX|WITH_POSITION Comment name
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Lexicon blog_content COLUMN_INDEX|WITH_POSITION Blog content
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>Sample data:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Comment
[
{&quot;_key&quot;: 1, &quot;name&quot;: &quot;A&quot;, &quot;content&quot;: &quot;groonga&quot;},
{&quot;_key&quot;: 2, &quot;name&quot;: &quot;B&quot;, &quot;content&quot;: &quot;groonga&quot;},
{&quot;_key&quot;: 3, &quot;name&quot;: &quot;C&quot;, &quot;content&quot;: &quot;rroonga&quot;},
{&quot;_key&quot;: 4, &quot;name&quot;: &quot;A&quot;, &quot;content&quot;: &quot;mroonga&quot;},
]
# [[0, 1337566253.89858, 0.000355720520019531], 4]
load --table Blog
[
{&quot;_key&quot;: &quot;groonga&#39;s blog&quot;, &quot;content&quot;: &quot;content of groonga&#39;s blog&quot;, comments: [1, 2, 3]},
{&quot;_key&quot;: &quot;mroonga&#39;s blog&quot;, &quot;content&quot;: &quot;content of mroonga&#39;s blog&quot;, comments: [2, 3, 4]},
{&quot;_key&quot;: &quot;rroonga&#39;s blog&quot;, &quot;content&quot;: &quot;content of rroonga&#39;s blog&quot;, comments: [3]},
]
# [[0, 1337566253.89858, 0.000355720520019531], 3]
</pre></div>
</div>
<p>Here is the simple usage of <code class="docutils literal notranslate"><span class="pre">sub_filter</span></code> function which extracts the
blog entry commented by user ‘A’.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Blog --output_columns _key --filter &quot;comments.name @ \&quot;A\&quot; &amp;&amp; comments.content @ \&quot;groonga\&quot;&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         2
#       ],
#       [
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         &quot;groonga&#39;s blog&quot;
#       ],
#       [
#         &quot;mroonga&#39;s blog&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>When executing the above query, not only “groonga’s blog”, but also “mroonga’s blog”.
This is not what you want because user “A” does not mention “groonga” to “mroonga’s blog”.</p>
<p>Without sub_filter, it means that following conditions are met.</p>
<ul class="simple">
<li><p>There is at least one record that user “A” commented out.</p></li>
<li><p>There is at least one record that mentioned about “groonga”.</p></li>
</ul>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Blog --output_columns _key --filter &#39;sub_filter(comments, &quot;name @ \\&quot;A\\&quot; &amp;&amp; content @ \\&quot;groonga\\&quot;&quot;)&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         &quot;groonga&#39;s blog&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>On the other hand, executing the above query returns the intended result.
Because the arguments of sub_filter is evaluated in comments column’s context.</p>
<p>It means that sub_filter requires the following condition is met.</p>
<ul class="simple">
<li><p>There are the records that user “A” mentions about “groonga”.</p></li>
</ul>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.15.22.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>There are two required parameter, <code class="docutils literal notranslate"><span class="pre">scope</span></code> and <code class="docutils literal notranslate"><span class="pre">filter_string</span></code>.</p>
<div class="section" id="scope">
<h3><span class="section-number">7.15.22.4.1. </span><code class="docutils literal notranslate"><span class="pre">scope</span></code><a class="headerlink" href="#scope" title="Permalink to this headline">¶</a></h3>
<p>Specifies a column of the table that is specified by <code class="docutils literal notranslate"><span class="pre">table</span></code>
parameter in <code class="docutils literal notranslate"><span class="pre">select</span></code>. The column has a limitation. The limitation
is described later. <code class="docutils literal notranslate"><span class="pre">filter_string</span></code> is evaluated in the column
context. It means that <code class="docutils literal notranslate"><span class="pre">filter_string</span></code> is evaluated like
<code class="docutils literal notranslate"><span class="pre">select</span> <span class="pre">--table</span> <span class="pre">TYPE_OF_THE_COLUMN</span> <span class="pre">--filter</span> <span class="pre">FILTER_STRING</span></code>.</p>
<p>The specified column type must be a table. In other words, the column
type must be reference type.</p>
<p>You can chain columns by <code class="docutils literal notranslate"><span class="pre">COLUMN_1.COLUMN_2.COLUMN_3...COLUMN_N</span></code>
syntax. For example, <code class="docutils literal notranslate"><span class="pre">user.group.name</span></code>.</p>
<p>See <a class="reference internal" href="../commands/select.html#select-table"><span class="std std-ref">table</span></a> about <code class="docutils literal notranslate"><span class="pre">table</span></code> parameter in <code class="docutils literal notranslate"><span class="pre">select</span></code>.</p>
</div>
<div class="section" id="filter-string">
<h3><span class="section-number">7.15.22.4.2. </span><code class="docutils literal notranslate"><span class="pre">filter_string</span></code><a class="headerlink" href="#filter-string" title="Permalink to this headline">¶</a></h3>
<p>Specifies a search condition in
<a class="reference internal" href="../grn_expr/script_syntax.html"><span class="doc">Script syntax</span></a>. It is evaluated in <code class="docutils literal notranslate"><span class="pre">scope</span></code>
context.</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.22.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code> returns whether any record is matched or not. If one or
more records are matched, it returns <code class="docutils literal notranslate"><span class="pre">true</span></code>. Otherwise, it returns
<code class="docutils literal notranslate"><span class="pre">false</span></code>.</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.15.22.6. </span>See also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a></p></li>
<li><p><a class="reference internal" href="../grn_expr/script_syntax.html"><span class="doc">Script syntax</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.22. <code class="docutils literal notranslate"><span class="pre">sub_filter</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.22.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.15.22.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.15.22.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.15.22.4. Parameters</a><ul>
<li><a class="reference internal" href="#scope">7.15.22.4.1. <code class="docutils literal notranslate"><span class="pre">scope</span></code></a></li>
<li><a class="reference internal" href="#filter-string">7.15.22.4.2. <code class="docutils literal notranslate"><span class="pre">filter_string</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.22.5. Return value</a></li>
<li><a class="reference internal" href="#see-also">7.15.22.6. See also</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="string_substring.html"
                        title="previous chapter"><span class="section-number">7.15.21. </span><code class="docutils literal notranslate"><span class="pre">string_substring</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="time_classify_day.html"
                        title="next chapter"><span class="section-number">7.15.23. </span><code class="docutils literal notranslate"><span class="pre">time_classify_day</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="time_classify_day.html" title="7.15.23. time_classify_day"
             >next</a> |</li>
        <li class="right" >
          <a href="string_substring.html" title="7.15.21. string_substring"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.22. </span><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>